
Object subclass: #SupplyPalette
    instanceVariableNames: 'product suppliedQuantity '
    classVariableNames: ''
    poolDictionaries: ''!

SupplyPalette comment: 'Diese Klasse entspricht der Klasse Palette aus der OBA-Analyse.

Instanzvariablen:
	product <Product>
		Das auf der Palette liegende ''Produkt''.
	suppliedQuantity <Number>
		Die ''Liefermenge'' des Produktes.
'!

!SupplyPalette class publicMethods !

new
	"Instanzvariablen werden initialisiert."
	^super new initialize! !

SupplyPalette class categoriesFor: #new are:((OrderedCollection new)
	add: 'Create';
	yourself)!

!SupplyPalette publicMethods !

initialize
	"Anfangswerte werden gesetzt."
	product := nil.
	suppliedQuantity := 0
	!

printString
	"Gibt Produkt und Menge auf der Palette aus."
	^'Palette with ' , self suppliedQuantity printString ,
		' units of (' , self product printString , ')'!

product
	"Entspricht der Dienstleistung 'Produkt'."
	^product!

product: aProduct
	"Palette wird mit angegebenes Produkt bestueckt."
	product := aProduct!

release
	"Objektdaten werden geloescht."
	product := nil.
	suppliedQuantity := nil
	!

suppliedQuantity
	"Zugriff 'Liefermenge'."
	"Liefermenge des entsprechenden Produkts auf der Palette."
	^suppliedQuantity!

suppliedQuantity: aNumber
	"Setzt Liefermenge des Produkt auf der Palette fest."
	suppliedQuantity := aNumber
! !

SupplyPalette categoriesFor: #product are:((OrderedCollection new)
	add: 'Services';
	yourself)!
SupplyPalette categoriesFor: #release are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
SupplyPalette categoriesFor: #initialize are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
SupplyPalette categoriesFor: #product: are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
SupplyPalette categoriesFor: #suppliedQuantity: are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
SupplyPalette categoriesFor: #suppliedQuantity are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
SupplyPalette categoriesFor: #printString are:((OrderedCollection new)
	add: 'Printing';
	yourself)!