
StorageArea subclass: #Storage
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

Storage comment: 'Diese Klasse entspricht der Klasse Regal aus der OBA-Analyse.'!

!Storage publicMethods !

initialize: aPoint
	"Zusaetzlich muessen noch die Regalfaecher eingerichtet werden."
	super initialize: aPoint.
	1 to: aPoint x do: [:u | 1 to: aPoint y do:
		[:v | places at: u @ v put: StorageShelf new]]!

isUsedAt: aPoint
	"Zugriff 'Belegt'."
	"Reimplementierung wegen Belegung der Plaetze
	durch Regalfaecher."
	^(self at: aPoint) isEmpty not!

release
	"Zusaetzlich muessen alle Regalfaecher geloescht werden."
	super usedPlacesDo: [:place | place release].
	super release!

usedPlacesDo: aBinaryBlock
	"Reimplementierung wegen Belegung der Plaetze
	durch Regalfaecher."
	super usedPlacesDo: [:point :shelf | shelf isEmpty
		ifFalse: [aBinaryBlock value: point value: shelf]]
!

usedSpace
	"Anzahl der belegten Plaetze. Reimplementierung, da leere
	Regalfaecher gesucht werden muessen."
	^places inject: 0 into:
		[:subTotal :next | subTotal +
			(next isEmpty ifTrue: [0] ifFalse: [1])]
! !

Storage categoriesFor: #release are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
Storage categoriesFor: #initialize: are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
Storage categoriesFor: #usedPlacesDo: are:((OrderedCollection new)
	add: 'Enumerating';
	yourself)!
Storage categoriesFor: #isUsedAt: are:((OrderedCollection new)
	add: 'Testing';
	yourself)!
Storage categoriesFor: #usedSpace are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!