
Object subclass: #StorageShelf
    instanceVariableNames: 'palette storedQuantity '
    classVariableNames: ''
    poolDictionaries: ''!

StorageShelf comment: 'Diese Klasse entspricht der Klasse Regalfach aus der OBA-Analyse.

Instanzvariablen:
	palette <SupplyPalette>
		Die im Regalfach liegende ''Palette''.
	storedQuantity <Number>
		Im Regalfach enthaltene ''Fuellmenge'' des Produktes.
'!

!StorageShelf class publicMethods !

new
	"Instanzvariablen werden initialisiert."
	^super new initialize! !

StorageShelf class categoriesFor: #new are:((OrderedCollection new)
	add: 'Create';
	yourself)!

!StorageShelf publicMethods !

clear
	"Entspricht der Dienstleistung 'Leeren'."
	palette := nil.
	storedQuantity := 0	!

initialize
	"Anfangswerte werden gesetzt."
	palette := nil.
	storedQuantity := 0	!

isEmpty
	"Das Regalfach ist leer."
	^palette isNil!

pick: aNumber
	"Entspricht der Dienstleistung 'Entnehmen'."
	aNumber <= storedQuantity
		ifFalse: [^self error: 'No such amount available in shelf.'].
	storedQuantity := storedQuantity - aNumber!

product
	"Zugriff 'Produkt'."
	"Das auf der Palette im Regalfach liegende Produkt."
	^palette product!

release
	"Objektdaten werden geloescht."
	palette := nil.
	storedQuantity := nil	!

store: aSupplyPalette
	"Entspricht der Dienstleistung 'Einlagern'."
	palette := aSupplyPalette.
	storedQuantity := aSupplyPalette suppliedQuantity!

storedQuantity
	"Zugriff 'Fuellmenge'."
	"Die im Fach liegende Menge des Produkts."
	^storedQuantity! !

StorageShelf categoriesFor: #product are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
StorageShelf categoriesFor: #release are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
StorageShelf categoriesFor: #clear are:((OrderedCollection new)
	add: 'Services';
	yourself)!
StorageShelf categoriesFor: #store: are:((OrderedCollection new)
	add: 'Services';
	yourself)!
StorageShelf categoriesFor: #initialize are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
StorageShelf categoriesFor: #storedQuantity are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
StorageShelf categoriesFor: #isEmpty are:((OrderedCollection new)
	add: 'Testing';
	yourself)!
StorageShelf categoriesFor: #pick: are:((OrderedCollection new)
	add: 'Services';
	yourself)!